Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2408)
@@ -1,4 +1,4 @@
 !
-! $Id$
+! $Header$
 !
 MODULE phys_output_write_mod
@@ -25,8 +25,9 @@
 
     USE dimphy, only: klon, klev, klevp1, nslay
-    USE control_mod, only: day_step, iphysiq
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+    USE time_phylmdz_mod, only: day_step_phy, start_time, itau_phy
     USE phys_output_ctrlout_mod, only: o_phis, o_aire, is_ter, is_lic, is_oce, &
          is_ave, is_sic, o_contfracATM, o_contfracOR, &
-         o_aireTER, o_flat, o_slp, o_tsol, &
+         o_aireTER, o_flat, o_slp, o_ptstar, o_pt0, o_tsol, &
          o_t2m, o_t2m_min, o_t2m_max, &
          o_t2m_min_mon, o_t2m_max_mon, &
@@ -70,4 +71,9 @@
          o_tSTDlevs, epsfra, o_t_oce_sic, &
          o_ale_bl, o_alp_bl, o_ale_wk, o_alp_wk, &
+         o_dtvdf_x    , o_dtvdf_w    , o_dqvdf_x    , o_dqvdf_w    , &
+         o_sens_x     , o_sens_w     , o_flat_x     , o_flat_w     , &
+         o_delta_tsurf, &
+         o_cdragh_x   , o_cdragh_w   , o_cdragm_x   , o_cdragm_w   , &
+         o_kh         , o_kh_x       , o_kh_w       , &
          o_ale, o_alp, o_cin, o_WAPE, o_wake_h, &
          o_wake_s, o_wake_deltat, o_wake_deltaq, &
@@ -132,5 +138,7 @@
          o_duvdf, o_dvvdf, o_duoro, o_dvoro, &
          o_dtoro, o_dulif, o_dvlif, o_dtlif, &
-         o_duhin, o_dvhin, o_dthin, o_dqch4, o_rsu, &
+         o_du_gwd_hines, o_dv_gwd_hines, o_dthin, o_dqch4, o_rsu, &
+         o_du_gwd_front, o_dv_gwd_front, &
+         o_east_gwstress, o_west_gwstress, &
          o_rsd, o_rlu, o_rld, o_rsucs, o_rsdcs, &
          o_rlucs, o_rldcs, o_tnt, o_tntr, &
@@ -151,5 +159,6 @@
          o_dtr_ls, o_dtr_trsp, o_dtr_sscav, &
          o_dtr_sat, o_dtr_uscav, o_trac_cum, o_du_gwd_rando, o_dv_gwd_rando, &
-         o_vstr_gwd_rando
+         o_ustr_gwd_hines,o_vstr_gwd_hines,o_ustr_gwd_rando,o_vstr_gwd_rando, &
+         o_ustr_gwd_front,o_vstr_gwd_front
 
     USE phys_state_var_mod, only: pctsrf, paire_ter, rain_fall, snow_fall, &
@@ -160,7 +169,8 @@
          SWdn200, SWdn200clr, LWup200, LWup200clr, &
          LWdn200, LWdn200clr, solsw, solsw0, sollw, &
-         radsol, sollw0, sollwdown, sollw, gustiness, &
+         radsol, swradcorr, sollw0, sollwdown, sollw, gustiness, &
          sollwdownclr, lwdn0, ftsol, ustar, u10m, &
          v10m, pbl_tke, wake_delta_pbl_TKE, &
+         delta_tsurf, &
          wstar, cape, ema_pcb, ema_pct, &
          ema_cbmf, Ma, fm_therm, ale_bl, alp_bl, ale, &
@@ -174,10 +184,10 @@
          vqsumSTD, vTsumSTD, O3daysumSTD, wqsumSTD, &
          vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, &
-         T2sumSTD, nlevSTD, du_gwd_rando, dv_gwd_rando, &
+         T2sumSTD, nlevSTD, du_gwd_rando, du_gwd_front, &
          ulevSTD, vlevSTD, wlevSTD, philevSTD, qlevSTD, tlevSTD, &
          rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, &
          vphiSTD, wTSTD, u2STD, v2STD, T2STD, missing_val_nf90
 
-    USE phys_local_var_mod, only: zxfluxlat, slp, zxtsol, zt2m, &
+    USE phys_local_var_mod, only: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
          t2m_min_mon, t2m_max_mon, evap, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
@@ -193,5 +203,10 @@
          s_pblh, s_pblt, s_lcl, s_therm, uwriteSTD, &
          vwriteSTD, wwriteSTD, phiwriteSTD, qwriteSTD, &
-         twriteSTD, ale_wake, alp_wake, wake_h, &
+         twriteSTD, ale_wake, alp_wake, &
+         dtvdf_x    ,dtvdf_w    ,dqvdf_x    ,dqvdf_w    , &
+         sens_x     ,sens_w     ,zxfluxlat_x,zxfluxlat_w, &
+         cdragh_x   ,cdragh_w   ,cdragm_x   ,cdragm_w   , &
+         kh         ,kh_x       ,kh_w       , &
+         wake_h, &
          wake_omg, d_t_wake, d_q_wake, Vprecip, &
          wdtrainA, wdtrainM, n2, s2, proba_notrig, &
@@ -230,15 +245,19 @@
          zw2, fraca, zmax_th, d_q_ajsb, d_t_ec, d_u_vdf, &
          d_v_vdf, d_u_oro, d_v_oro, d_t_oro, d_u_lif, &
-         d_v_lif, d_t_lif, d_u_hin, d_v_hin, d_t_hin, &
+         d_v_lif, d_t_lif, du_gwd_hines, dv_gwd_hines, d_t_hin, &
+         dv_gwd_rando, dv_gwd_front, &
+         east_gwstress, west_gwstress, &
          d_q_ch4, pmfd, pmfu, ref_liq, ref_ice, rhwriteSTD
 
     USE phys_output_var_mod, only: vars_defined, snow_o, zfra_o, bils_diss, &
          bils_ec,bils_ech, bils_tke, bils_kinetic, bils_latent, bils_enthalp, &
-         itau_con, nfiles, clef_files, nid_files, zvstr_gwd_rando
+         itau_con, nfiles, clef_files, nid_files, &
+         zustr_gwd_hines, zvstr_gwd_hines,zustr_gwd_rando, zvstr_gwd_rando, &
+         zustr_gwd_front, zvstr_gwd_front                                   
     USE ocean_slab_mod, only: tslab, slab_bils, slab_bilg, tice, seaice
     USE pbl_surface_mod, only: snow
     USE indice_sol_mod, only: nbsrf
-    USE infotrac, only: nqtot, nqo, type_trac
-    USE comgeomphy, only: airephy
+    USE infotrac_phy, only: nqtot, nqo, type_trac
+    USE geometry_mod, only: cell_area
     USE surface_data, only: type_ocean, version_ocean, ok_veget, ok_snow
 !    USE aero_mod, only: naero_spc
@@ -247,4 +266,6 @@
     USE iophy, only: set_itau_iophy, histwrite_phy
     USE netcdf, only: nf90_fill_real
+    USE print_control_mod, ONLY: prt_level,lunout
+
 
 #ifdef CPP_XIOS
@@ -259,11 +280,8 @@
 
 
-    INCLUDE "temps.h"
     INCLUDE "clesphys.h"
     INCLUDE "thermcell.h"
     INCLUDE "compbl.h"
     INCLUDE "YOMCST.h"
-    INCLUDE "dimensions.h"
-    include "iniprint.h"
 
     ! Input
@@ -280,5 +298,5 @@
     REAL, DIMENSION(klon, klev+1) :: paprs
     REAL, DIMENSION(klon,klev,nqtot) :: qx, d_qx
-    REAL, DIMENSION(klon, llm) :: zmasse
+    REAL, DIMENSION(klon, klev) :: zmasse
     LOGICAL :: flag_aerosol_strat
     INTEGER :: flag_aerosol 
@@ -287,5 +305,4 @@
 
     ! Local
-    INTEGER, PARAMETER :: jjmp1=jjm+1-1/jjm
     INTEGER :: itau_w
     INTEGER :: i, iinit, iinitend=1, iff, iq, nsrf, k, ll, naero
@@ -294,6 +311,6 @@
     REAL, DIMENSION (klon,klev+1) :: zx_tmp_fi3d1
     CHARACTER (LEN=4)              :: bb2
-    INTEGER, DIMENSION(iim*jjmp1)  :: ndex2d
-    INTEGER, DIMENSION(iim*jjmp1*klev) :: ndex3d
+    INTEGER, DIMENSION(nbp_lon*nbp_lat)  :: ndex2d
+    INTEGER, DIMENSION(nbp_lon*nbp_lat*klev) :: ndex3d
     REAL, PARAMETER :: dobson_u = 2.1415e-05 ! Dobson unit, in kg m-2
 !   REAL, PARAMETER :: missing_val=nf90_fill_real
@@ -304,5 +321,5 @@
 
     ! On calcul le nouveau tau:
-    itau_w = itau_phy + itap + start_time * day_step / iphysiq
+    itau_w = itau_phy + itap + start_time * day_step_phy
     ! On le donne à iophy pour que les histwrite y aient accès:
     CALL set_itau_iophy(itau_w)
@@ -331,5 +348,5 @@
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        CALL histwrite_phy(o_phis, pphis)
-       CALL histwrite_phy(o_aire, airephy)
+       CALL histwrite_phy(o_aire, cell_area)
 
        IF (vars_defined) THEN
@@ -344,4 +361,6 @@
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        CALL histwrite_phy(o_flat, zxfluxlat)
+       CALL histwrite_phy(o_ptstar, ptstar)
+       CALL histwrite_phy(o_pt0, pt0)
        CALL histwrite_phy(o_slp, slp)
        CALL histwrite_phy(o_tsol, zxtsol)
@@ -418,69 +437,69 @@
        CALL histwrite_phy(o_fsnow, zfra_o)
        CALL histwrite_phy(o_evap, evap)
-       CALL histwrite_phy(o_tops, topsw)
-       CALL histwrite_phy(o_tops0, topsw0)
+       CALL histwrite_phy(o_tops, topsw*swradcorr)
+       CALL histwrite_phy(o_tops0, topsw0*swradcorr)
        CALL histwrite_phy(o_topl, toplw)
        CALL histwrite_phy(o_topl0, toplw0)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, klevp1 )
+          zx_tmp_fi2d(:) = swup(:,klevp1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWupTOA, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, klevp1 )
+          zx_tmp_fi2d(:) = swup0(:,klevp1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWupTOAclr, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, klevp1 )
+          zx_tmp_fi2d(:) = swdn(:,klevp1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWdnTOA, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, klevp1 )
+          zx_tmp_fi2d(:) = swdn0(:,klevp1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWdnTOAclr, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(:) = topsw(:)-toplw(:)
+          zx_tmp_fi2d(:) = topsw(:)*swradcorr(:)-toplw(:)
        ENDIF
        CALL histwrite_phy(o_nettop, zx_tmp_fi2d)
-       CALL histwrite_phy(o_SWup200, SWup200)
-       CALL histwrite_phy(o_SWup200clr, SWup200clr)
-       CALL histwrite_phy(o_SWdn200, SWdn200)
-       CALL histwrite_phy(o_SWdn200clr, SWdn200clr)
+       CALL histwrite_phy(o_SWup200, SWup200*swradcorr)
+       CALL histwrite_phy(o_SWup200clr, SWup200clr*swradcorr)
+       CALL histwrite_phy(o_SWdn200, SWdn200*swradcorr)
+       CALL histwrite_phy(o_SWdn200clr, SWdn200clr*swradcorr)
        CALL histwrite_phy(o_LWup200, LWup200)
        CALL histwrite_phy(o_LWup200clr, LWup200clr)
        CALL histwrite_phy(o_LWdn200, LWdn200)
        CALL histwrite_phy(o_LWdn200clr, LWdn200clr)
-       CALL histwrite_phy(o_sols, solsw)
-       CALL histwrite_phy(o_sols0, solsw0)
+       CALL histwrite_phy(o_sols, solsw*swradcorr)
+       CALL histwrite_phy(o_sols0, solsw0*swradcorr)
        CALL histwrite_phy(o_soll, sollw)
+       CALL histwrite_phy(o_soll0, sollw0)
        CALL histwrite_phy(o_radsol, radsol)
-       CALL histwrite_phy(o_soll0, sollw0)
-
-       IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, 1 )
+
+       IF (vars_defined) THEN
+          zx_tmp_fi2d(:) = swup(:,1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWupSFC, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, 1 )
+          zx_tmp_fi2d(:) = swup0(:,1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWupSFCclr, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, 1 )
+          zx_tmp_fi2d(:) = swdn(:,1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWdnSFC, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, 1 )
+          zx_tmp_fi2d(:) = swdn0(:,1)*swradcorr(:)
        ENDIF
        CALL histwrite_phy(o_SWdnSFCclr, zx_tmp_fi2d)
 
        IF (vars_defined) THEN
-          zx_tmp_fi2d(1:klon)=sollwdown(1:klon)-sollw(1:klon)
+          zx_tmp_fi2d(:)=sollwdown(:)-sollw(:)
        ENDIF
        CALL histwrite_phy(o_LWupSFC, zx_tmp_fi2d)
@@ -746,4 +765,26 @@
              CALL histwrite_phy(o_ale_wk, ale_wake)
              CALL histwrite_phy(o_alp_wk, alp_wake)
+             IF (iflag_pbl_split>=1) THEN
+               IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=dtvdf_x(1:klon,1:klev)/pdtphys
+               CALL histwrite_phy(o_dtvdf_x    ,zx_tmp_fi3d) 
+               IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=dtvdf_w(1:klon,1:klev)/pdtphys
+               CALL histwrite_phy(o_dtvdf_w    ,zx_tmp_fi3d) 
+               IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=dqvdf_x(1:klon,1:klev)/pdtphys
+               CALL histwrite_phy(o_dqvdf_x    ,zx_tmp_fi3d) 
+               IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=dqvdf_w(1:klon,1:klev)/pdtphys
+               CALL histwrite_phy(o_dqvdf_w    ,zx_tmp_fi3d) 
+               CALL histwrite_phy(o_sens_x     ,sens_x     ) 
+               CALL histwrite_phy(o_sens_w     ,sens_w     ) 
+               CALL histwrite_phy(o_flat_x     ,zxfluxlat_x) 
+               CALL histwrite_phy(o_flat_w     ,zxfluxlat_w) 
+               CALL histwrite_phy(o_delta_tsurf,delta_tsurf) 
+               CALL histwrite_phy(o_cdragh_x   ,cdragh_x   ) 
+               CALL histwrite_phy(o_cdragh_w   ,cdragh_w   ) 
+               CALL histwrite_phy(o_cdragm_x   ,cdragm_x   ) 
+               CALL histwrite_phy(o_cdragm_w   ,cdragm_w   ) 
+               CALL histwrite_phy(o_kh         ,kh         ) 
+               CALL histwrite_phy(o_kh_x       ,kh_x       ) 
+               CALL histwrite_phy(o_kh_w       ,kh_w       ) 
+             ENDIF   ! (iflag_pbl_split>=1)
              CALL histwrite_phy(o_ale, ale)
              CALL histwrite_phy(o_alp, alp)
@@ -895,8 +936,8 @@
        ENDIF
        IF (ok_ade) THEN
-          CALL histwrite_phy(o_topswad, topswad_aero)
-          CALL histwrite_phy(o_topswad0, topswad0_aero)
-          CALL histwrite_phy(o_solswad, solswad_aero)
-          CALL histwrite_phy(o_solswad0, solswad0_aero)
+          CALL histwrite_phy(o_topswad, topswad_aero*swradcorr)
+          CALL histwrite_phy(o_topswad0, topswad0_aero*swradcorr)
+          CALL histwrite_phy(o_solswad, solswad_aero*swradcorr)
+          CALL histwrite_phy(o_solswad0, solswad0_aero*swradcorr)
           CALL histwrite_phy(o_toplwad, toplwad_aero)
           CALL histwrite_phy(o_toplwad0, toplwad0_aero)
@@ -905,21 +946,35 @@
           !====MS forcing diagnostics
           if (new_aod) then
-             CALL histwrite_phy(o_swtoaas_nat, topsw_aero(:,1))
-             CALL histwrite_phy(o_swsrfas_nat, solsw_aero(:,1))
-             CALL histwrite_phy(o_swtoacs_nat, topsw0_aero(:,1))
-             CALL histwrite_phy(o_swsrfcs_nat, solsw0_aero(:,1))
+             zx_tmp_fi2d(:)=topsw_aero(:,1)*swradcorr(:)
+             CALL histwrite_phy(o_swtoaas_nat,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=solsw_aero(:,1)*swradcorr(:)
+             CALL histwrite_phy(o_swsrfas_nat,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=topsw0_aero(:,1)*swradcorr(:)
+             CALL histwrite_phy(o_swtoacs_nat,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=solsw0_aero(:,1)*swradcorr(:)
+             CALL histwrite_phy(o_swsrfcs_nat,zx_tmp_fi2d)
              !ant
-             CALL histwrite_phy(o_swtoaas_ant, topsw_aero(:,2))
-             CALL histwrite_phy(o_swsrfas_ant, solsw_aero(:,2))
-             CALL histwrite_phy(o_swtoacs_ant, topsw0_aero(:,2))
-             CALL histwrite_phy(o_swsrfcs_ant, solsw0_aero(:,2))
+             zx_tmp_fi2d(:)=topsw_aero(:,2)*swradcorr(:)
+             CALL histwrite_phy(o_swtoaas_ant,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=solsw_aero(:,2)*swradcorr(:)
+             CALL histwrite_phy(o_swsrfas_ant,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=topsw0_aero(:,2)*swradcorr(:)
+             CALL histwrite_phy(o_swtoacs_ant,zx_tmp_fi2d)
+             zx_tmp_fi2d(:)=solsw0_aero(:,2)*swradcorr(:)
+             CALL histwrite_phy(o_swsrfcs_ant,zx_tmp_fi2d)
              !cf
              if (.not. aerosol_couple) then
-                CALL histwrite_phy(o_swtoacf_nat, topswcf_aero(:,1))
-                CALL histwrite_phy(o_swsrfcf_nat, solswcf_aero(:,1))
-                CALL histwrite_phy(o_swtoacf_ant, topswcf_aero(:,2))
-                CALL histwrite_phy(o_swsrfcf_ant, solswcf_aero(:,2))
-                CALL histwrite_phy(o_swtoacf_zero,topswcf_aero(:,3))
-                CALL histwrite_phy(o_swsrfcf_zero,solswcf_aero(:,3))
+                zx_tmp_fi2d(:)=topswcf_aero(:,1)*swradcorr(:)
+                CALL histwrite_phy(o_swtoacf_nat,zx_tmp_fi2d)
+                zx_tmp_fi2d(:)=solswcf_aero(:,1)*swradcorr(:)
+                CALL histwrite_phy(o_swsrfcf_nat,zx_tmp_fi2d)
+                zx_tmp_fi2d(:)=topswcf_aero(:,2)*swradcorr(:)
+                CALL histwrite_phy(o_swtoacf_ant,zx_tmp_fi2d)
+                zx_tmp_fi2d(:)=solswcf_aero(:,2)*swradcorr(:)
+                CALL histwrite_phy(o_swsrfcf_ant,zx_tmp_fi2d)
+                zx_tmp_fi2d(:)=topswcf_aero(:,3)*swradcorr(:)
+                CALL histwrite_phy(o_swtoacf_zero,zx_tmp_fi2d)
+                zx_tmp_fi2d(:)=solswcf_aero(:,3)*swradcorr(:)
+                CALL histwrite_phy(o_swsrfcf_zero,zx_tmp_fi2d)
              endif
           endif ! new_aod
@@ -927,6 +982,6 @@
        ENDIF
        IF (ok_aie) THEN
-          CALL histwrite_phy(o_topswai, topswai_aero)
-          CALL histwrite_phy(o_solswai, solswai_aero)
+          CALL histwrite_phy(o_topswai, topswai_aero*swradcorr)
+          CALL histwrite_phy(o_solswai, solswai_aero*swradcorr)
        ENDIF
        IF (flag_aerosol.GT.0.AND.ok_cdnc) THEN
@@ -959,34 +1014,15 @@
        CALL histwrite_phy(o_pres, pplay)
        CALL histwrite_phy(o_paprs, paprs(:,1:klev))
-       IF (vars_defined) THEN
-          DO i=1, klon
-             zx_tmp_fi3d1(i,1)= pphis(i)/RG
-             !020611   zx_tmp_fi3d(i,1)= pphis(i)/RG
-          ENDDO
-          DO k=1, klev
-             !020611        DO k=1, klev-1
-             DO i=1, klon
-                !020611         zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - (t_seri(i,k) *RD * 
-                zx_tmp_fi3d1(i,k+1)= zx_tmp_fi3d1(i,k) - (t_seri(i,k) *RD *  &
-                     (paprs(i,k+1) - paprs(i,k))) / ( pplay(i,k) * RG ) 
-             ENDDO
-          ENDDO
-       ENDIF
-       CALL histwrite_phy(o_zfull,zx_tmp_fi3d1(:,2:klevp1))
-       !020611    $o_zfull%name,itau_w,zx_tmp_fi3d)
+       CALL histwrite_phy(o_zfull,zphi/RG)
 
        IF (vars_defined)  THEN
-          DO i=1, klon
-             zx_tmp_fi3d(i,1)= pphis(i)/RG - ( &
-                  (t_seri(i,1)+zxtsol(i))/2. *RD * &
-                  (pplay(i,1) - paprs(i,1)))/( (paprs(i,1)+pplay(i,1))/2.* RG)
-          ENDDO
-          DO k=1, klev-1
-             DO i=1, klon
-                zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - ( &
-                     (t_seri(i,k)+t_seri(i,k+1))/2. *RD *  &
-                     (pplay(i,k+1) - pplay(i,k))) / ( paprs(i,k) * RG ) 
-             ENDDO
-          ENDDO
+        zx_tmp_fi3d(:,1)= pphis(:)/RG
+        DO k = 2, klev
+         DO i = 1, klon
+            zx_tmp_fi3d(i,k) = zphi(i,k)/RG + &
+                          (zphi(i,k)-zphi(i,k-1))/RG * &
+                          (paprs(i,k)-pplay(i,k))/(pplay(i,k)-pplay(i,k-1))
+         ENDDO
+        ENDDO
        ENDIF
        CALL histwrite_phy(o_zhalf, zx_tmp_fi3d)
@@ -1216,10 +1252,17 @@
 
        IF (ok_hines) THEN
-          IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_u_hin(1:klon,1:klev)/pdtphys
-          CALL histwrite_phy(o_duhin, zx_tmp_fi3d)
-          IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_v_hin(1:klon,1:klev)/pdtphys
-          CALL histwrite_phy(o_dvhin, zx_tmp_fi3d)
+          CALL histwrite_phy(o_du_gwd_hines, du_gwd_hines/pdtphys)
+          CALL histwrite_phy(o_dv_gwd_hines, dv_gwd_hines/pdtphys)
           IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_hin(1:klon,1:klev)/pdtphys
           CALL histwrite_phy(o_dthin, zx_tmp_fi3d)
+          CALL histwrite_phy(o_ustr_gwd_hines, zustr_gwd_hines)
+          CALL histwrite_phy(o_vstr_gwd_hines, zvstr_gwd_hines)
+       end IF
+
+       if (.not. ok_hines .and. ok_gwd_rando) then
+          CALL histwrite_phy(o_du_gwd_front, du_gwd_front / pdtphys)
+          CALL histwrite_phy(o_dv_gwd_front, dv_gwd_front / pdtphys)
+          CALL histwrite_phy(o_ustr_gwd_front, zustr_gwd_front)
+          CALL histwrite_phy(o_vstr_gwd_front, zvstr_gwd_front)
        ENDIF
 
@@ -1227,5 +1270,8 @@
           CALL histwrite_phy(o_du_gwd_rando, du_gwd_rando / pdtphys)
           CALL histwrite_phy(o_dv_gwd_rando, dv_gwd_rando / pdtphys)
+          CALL histwrite_phy(o_ustr_gwd_rando, zustr_gwd_rando)
           CALL histwrite_phy(o_vstr_gwd_rando, zvstr_gwd_rando)
+          CALL histwrite_phy(o_east_gwstress, east_gwstress )
+          CALL histwrite_phy(o_west_gwstress, west_gwstress )
        end IF
 
@@ -1234,12 +1280,26 @@
        ENDIF
 
-       CALL histwrite_phy(o_rsu, swup)
-       CALL histwrite_phy(o_rsd, swdn)
+       DO k=1, klevp1
+         zx_tmp_fi3d1(:,k)=swup(:,k)*swradcorr(:)
+       ENDDO
+       CALL histwrite_phy(o_rsu, zx_tmp_fi3d1)
+       DO k=1, klevp1
+         zx_tmp_fi3d1(:,k)=swdn(:,k)*swradcorr(:)
+       ENDDO
+       CALL histwrite_phy(o_rsd, zx_tmp_fi3d1)
+       DO k=1, klevp1
+         zx_tmp_fi3d1(:,k)=swup0(:,k)*swradcorr(:)
+       ENDDO
+       CALL histwrite_phy(o_rsucs, zx_tmp_fi3d1)
+       DO k=1, klevp1
+         zx_tmp_fi3d1(:,k)=swdn0(:,k)*swradcorr(:)
+       ENDDO
+       CALL histwrite_phy(o_rsdcs, zx_tmp_fi3d1)
+
        CALL histwrite_phy(o_rlu, lwup)
        CALL histwrite_phy(o_rld, lwdn)
-       CALL histwrite_phy(o_rsucs, swup0)
-       CALL histwrite_phy(o_rsdcs, swdn0)
        CALL histwrite_phy(o_rlucs, lwup0)
        CALL histwrite_phy(o_rldcs, lwdn0)
+
        IF(vars_defined) THEN
           zx_tmp_fi3d(1:klon,1:klev)=d_t(1:klon,1:klev)+ &
@@ -1247,4 +1307,5 @@
        ENDIF
        CALL histwrite_phy(o_tnt, zx_tmp_fi3d)
+
        IF(vars_defined) THEN
           zx_tmp_fi3d(1:klon,1:klev)=d_t_swr(1:klon,1:klev)/pdtphys + &
@@ -1294,19 +1355,31 @@
             RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR. &
             RCFC12_per.NE.RCFC12_act) THEN
-          IF(vars_defined) zx_tmp_fi2d(1 : klon) = swupp ( 1 : klon, klevp1 )
+          IF(vars_defined) zx_tmp_fi2d(:) = swupp(:,klevp1)*swradcorr(:)
           CALL histwrite_phy(o_rsut4co2, zx_tmp_fi2d)
-          IF(vars_defined) zx_tmp_fi2d(1 : klon) = lwupp ( 1 : klon, klevp1 )
+          IF(vars_defined) zx_tmp_fi2d(:) = lwupp(:,klevp1)
           CALL histwrite_phy(o_rlut4co2, zx_tmp_fi2d)
-          IF(vars_defined) zx_tmp_fi2d(1 : klon) = swup0p ( 1 : klon, klevp1 )
+          IF(vars_defined) zx_tmp_fi2d(:) = swup0p(:,klevp1)*swradcorr(:)
           CALL histwrite_phy(o_rsutcs4co2, zx_tmp_fi2d)
-          IF(vars_defined) zx_tmp_fi2d(1 : klon) = lwup0p ( 1 : klon, klevp1 )
+          IF(vars_defined) zx_tmp_fi2d(:) = lwup0p(:,klevp1)
           CALL histwrite_phy(o_rlutcs4co2, zx_tmp_fi2d)
-          CALL histwrite_phy(o_rsu4co2, swupp)
+          DO k=1, klevp1
+            zx_tmp_fi3d1(:,k)=swupp(:,k)*swradcorr(:)
+          ENDDO
+          CALL histwrite_phy(o_rsu4co2, zx_tmp_fi3d1)
+          DO k=1, klevp1
+            zx_tmp_fi3d1(:,k)=swup0p(:,k)*swradcorr(:)
+          ENDDO
+          CALL histwrite_phy(o_rsucs4co2, zx_tmp_fi3d1)
+          DO k=1, klevp1
+            zx_tmp_fi3d1(:,k)=swdnp(:,k)*swradcorr(:)
+          ENDDO
+          CALL histwrite_phy(o_rsd4co2, zx_tmp_fi3d1)
+          DO k=1, klevp1
+            zx_tmp_fi3d1(:,k)=swdn0p(:,k)*swradcorr(:)
+          ENDDO
+          CALL histwrite_phy(o_rsdcs4co2, zx_tmp_fi3d1)
           CALL histwrite_phy(o_rlu4co2, lwupp)
-          CALL histwrite_phy(o_rsucs4co2, swup0p)
           CALL histwrite_phy(o_rlucs4co2, lwup0p)
-          CALL histwrite_phy(o_rsd4co2, swdnp)
           CALL histwrite_phy(o_rld4co2, lwdnp)
-          CALL histwrite_phy(o_rsdcs4co2, swdn0p)
           CALL histwrite_phy(o_rldcs4co2, lwdn0p)
        ENDIF
Index: /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2408)
@@ -48,4 +48,6 @@
       REAL, ALLOCATABLE, SAVE :: radsol(:)
 !$OMP THREADPRIVATE(radsol)
+      REAL, ALLOCATABLE, SAVE :: swradcorr(:)
+!$OMP THREADPRIVATE(swradcorr)
 
 !clesphy0 param physiq
@@ -395,6 +397,6 @@
 !!! fin nrlmd le 10/04/2012
 
-      REAL, ALLOCATABLE, SAVE:: du_gwd_rando(:, :), dv_gwd_rando(:, :)
-      !$OMP THREADPRIVATE(du_gwd_rando, dv_gwd_rando)
+      REAL, ALLOCATABLE, SAVE:: du_gwd_rando(:, :), du_gwd_front(:, :)
+      !$OMP THREADPRIVATE(du_gwd_rando, du_gwd_front)
       ! tendencies on wind due to gravity waves
 
@@ -404,7 +406,6 @@
 SUBROUTINE phys_state_var_init(read_climoz)
 USE dimphy
-USE control_mod
 USE aero_mod
-USE infotrac, ONLY : nbtr
+USE infotrac_phy, ONLY : nbtr
 USE indice_sol_mod
 IMPLICIT NONE
@@ -434,4 +435,5 @@
       ALLOCATE(solsw(klon), sollw(klon))
       ALLOCATE(radsol(klon))
+      ALLOCATE(swradcorr(klon))
       ALLOCATE(zmea(klon), zstd(klon), zsig(klon), zgam(klon))
       ALLOCATE(zthe(klon), zpic(klon), zval(klon))
@@ -581,6 +583,6 @@
       ALLOCATE(ale_bl_trig(klon))
 !!! fin nrlmd le 10/04/2012
-      if (ok_gwd_rando) allocate(du_gwd_rando(klon, klev), &
-           dv_gwd_rando(klon, klev))
+      if (ok_gwd_rando) allocate(du_gwd_rando(klon, klev))
+      if (.not. ok_hines .and. ok_gwd_rando) allocate(du_gwd_front(klon, klev))
 
 END SUBROUTINE phys_state_var_init
@@ -589,5 +591,4 @@
 SUBROUTINE phys_state_var_end
 USE dimphy
-USE control_mod
 USE indice_sol_mod
 IMPLICIT NONE
@@ -596,5 +597,5 @@
       deallocate(rlat, rlon, pctsrf, ftsol, falb1, falb2)
       deallocate(qsol,fevap,z0m,z0h,agesno)
-      deallocate(rain_fall, snow_fall, solsw, sollw, radsol)
+      deallocate(rain_fall, snow_fall, solsw, sollw, radsol, swradcorr)
       deallocate(zmea, zstd, zsig, zgam)
       deallocate(zthe, zpic, zval)
@@ -705,5 +706,6 @@
       deallocate(tau_aero_lw_rrtm,piz_aero_lw_rrtm,cg_aero_lw_rrtm)
       deallocate(ccm)
-      if (ok_gwd_rando) deallocate(du_gwd_rando, dv_gwd_rando)
+      if (ok_gwd_rando) deallocate(du_gwd_rando)
+      if (.not. ok_hines .and. ok_gwd_rando) deallocate(du_gwd_front)
        
 !!! nrlmd le 10/04/2012
